defProperty('nClients', 3, "Number of client nodes to use, nClients = [1..7]")
defProperty('packetsize', 1024, "Packet size (byte) from the sender node, packetsize max = 1024")
defProperty('bitrate', 16384, "Bitrate (bit/s) from the sender node")

defApplication('ifconfig', 'ifconfig') {|a|
   a.name = "ifconfig" 
     a.version(0, 0, 1)
     a.path = "/sbin/ifconfig" 
  a.defProperty('args', "Arguments for ifconfig command", nil,  {:order => 1, :dynamic => false, :type => :string, :use_name => false})
}
defApplication('wimaxcu', 'wimaxcu') {|a|
   a.name = "wimaxcu" 
     a.version(0, 0, 1)
     a.path = "/usr/bin/wimaxcu" 
  a.defProperty('args', "Arguments for wimaxcu command", nil,  {:order => 1, :dynamic => false, :type => :string, :use_name => false})
}

defGroup('Receiver', [1,8]){ |node|
  node.addApplication('wimaxcu') { |app|
    app.setProperty('args','connect network 51')
  }
  node.addApplication("ifconfig") { |app|
    app.setProperty('args','wmx0 10.41.14.8 netmask 255.255.0.0')
  }
  node.addApplication("test:app:otr2") { |app|
    app.setProperty('udp:local_host', '10.41.14.8')
    app.setProperty('udp:local_port', 3000)
    app.measure('udp_in', :interval => 0.01)
    #{ |mp|
    #  mp.filter('packet_length', 'avg', :input => 'pkt_length')
    #}
  }
}

(1..property.nClients).each do |a|
  info "Group Sender: #{a.to_i}" 
  defGroup('Sender'+a.to_s, [1,a.to_i]) { |node|
    node.addApplication('wimaxcu') { |app|
      app.setProperty('args','connect network 51')
    }
    node.addApplication("ifconfig") { |app|
      app.setProperty('args','wmx0 10.41.14.'+a.to_s+' netmask 255.255.0.0')
    }
    node.addApplication("test:app:otg2") { |app|
      app.setProperty('udp:local_host', '10.41.14.'+a.to_s)
      app.setProperty('udp:dst_host', '10.41.14.8')		  	
      app.setProperty('udp:dst_port', 3000)
      app.setProperty('cbr:size',property.packetsize)  # Bytes
      app.setProperty('cbr:rate',property.bitrate) # bps
      app.measure('udp_out', :interval => 1.0)
    }
  }
end

whenAllInstalled() {|node|
  info "Give machines some time to warm up" 
  wait 5
  allGroups.startApplications
  info "Collect measurements for 60 seconds" 
  wait 60
  allGroups.stopApplications
  info "Finish it."
  wait 7
  
  system("cp /var/lib/oml2/#{Experiment.ID}.sq3 udp_n#{property.nClients}_p#{property.packetsize}_br#{property.bitrate}.sq3")
#  system("sqlite3 /var/lib/oml2/#{Experiment.ID}.sq3 \".dump\"")
  
  Experiment.done
}
